=== modified file 'register_accounting/account_invoice_view.xml'
--- register_accounting/account_invoice_view.xml	2011-04-08 12:17:55 +0000
+++ register_accounting/account_invoice_view.xml	2011-05-13 15:32:50 +0000
@@ -67,7 +67,7 @@
                                     <button name="invoice_cancel" states="draft,proforma2,sale,open" string="Cancel Invoice" icon="gtk-cancel"/>
                                     <button name="action_cancel_draft" states="cancel" string="Set to Draft" type="object" 
                                         icon="terp-stock_effects-object-colorize"/>
-                                    <button name="invoice_open" states="draft,proforma2" string="Approve" icon="terp-camera_test"/>
+                                    <button name="invoice_open" type="object" states="draft,proforma2" string="Approve" icon="terp-camera_test"/>
                                 </group>
                             </group>
                         </page>
@@ -150,5 +150,43 @@
     <!-- Supplier Direct Invoices Menu -->
         <menuitem action="action_direct_invoice" id="menu_action_direct_invoice" parent="account.menu_finance_payables"/>
 
+
+    <!-- Validate button is set as function -->
+        <record id="invoice_tree_2" model="ir.ui.view">
+            <field name="name">account.invoice.tree.2</field>
+            <field name="model">account.invoice</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="account.invoice_tree"/>
+            <field name="arch" type="xml">
+                <xpath expr="/tree/button[@name='invoice_open']" position="replace">
+                    <button name="invoice_open" states="draft,proforma2" type="object" string="Approve" icon="terp-camera_test"/>
+                </xpath>
+            </field>
+        </record>
+            
+        <record id="invoice_form_2" model="ir.ui.view">
+            <field name="name">account.invoice.form.2</field>
+            <field name="model">account.invoice</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="account.invoice_form"/>
+            <field name="arch" type="xml">
+                <button name='invoice_open' position="replace">
+                    <button name="invoice_open" states="draft,proforma2" type="object" string="Validate" icon="gtk-go-forward"/>
+                </button>
+            </field>
+        </record>
+            
+        <record id="invoice_supplier_form_2" model="ir.ui.view">
+            <field name="name">account.invoice.supplier.form.2</field>
+            <field name="model">account.invoice</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="account.invoice_supplier_form"/>
+            <field name="arch" type="xml">
+                <button name='invoice_open' position="replace">
+                    <button name="invoice_open" states="draft,proforma2" type="object" string="Validate" icon="gtk-go-forward"/>
+                </button>
+            </field>
+        </record>
+        
     </data>
 </openerp>

=== modified file 'register_accounting/invoice.py'
--- register_accounting/invoice.py	2011-04-08 12:17:55 +0000
+++ register_accounting/invoice.py	2011-05-13 15:32:50 +0000
@@ -23,6 +23,9 @@
 
 from osv import osv
 from osv import fields
+from tools.translate import _
+
+import netsvc
 
 class account_invoice(osv.osv):
     _name = 'account.invoice'
@@ -84,6 +87,17 @@
         Permit to refresh the wizard for direct invoice in order to compute the total of amount given by the invoices lines
         """
         return True
+    
+    def invoice_open(self, cr, uid, ids, context=None):
+        """
+        No longer fills the date automatically, but requires it to be set
+        """
+        wf_service = netsvc.LocalService("workflow")
+        for inv in self.browse(cr, uid, ids):
+            if not inv.date_invoice:
+                raise osv.except_osv(_('No invoice date !'), _('Please indicate an invoice date before approving the invoice!'))
+            wf_service.trg_validate(uid, 'account.invoice', inv.id, 'invoice_open', cr)
+        return True
 
 account_invoice()
 

